       program diff 

c      weak-strong simulation program
c      to study diffusion due to long-range
c      beam-beam force 
     
       INCLUDE 'param.f'

       external CFSTFT, c06ecf

         call readin 

         call init
c   
c       ntrack = 100000
c       ntrack = 1000
       npart = 169
       nloss = 0

c      NORMALLY:
c      ntrack = 100000
c      npart = 100

       ampl = 0.5*amp

       amxnt=1000.
       amxxt=0.
       amynt=1000.
       amyxt=0.

c      phase space tracing (short term) or 
c      action diffusion (long term)

c       iopt = %iop 
c      iopt = 3 - tune footprint (new)
c      iopt = 2 - frequency map 
c      iopt = 1 - short term, uniform distribution
c      iopt = 0 - long term, one amplitude only

       write(*,*) ' iopt decision ' 

       if (iopt.eq.3) then
c        footprint
         call initcoordfp 
         if (ntrack.gt.ntmapm) then
         write(*,*) ' ntrack>ntmapm - abunai! '
         stop
         endif
         do j = 1, npart
         do i = 1, ntrack
         xn(j,i) = 0.
         yn(j,i) = 0.
         pxn(j,i) = 0.
         pyn(j,i) = 0.
         end do 
         xn(j,1) = x(j)/sstar
         yn(j,1) = y(j)/sstar
         pxn(j,1) = px(j)/divstar
         pyn(j,1) = py(j)/divstar
         i0 = 0
         acomplx(indexfp1(j),indexfp2(j),i0)=cmplx(xx,xp) 
         acomply(indexfp1(j),indexfp2(j),i0)=cmplx(yy,yp) 
         end do 
       else if (iopt.eq.2) then
c        frequency map 
c         ntrack=%turnss
c         npart=%nangle   
         call initcoorduni 
         if (ntrack.gt.ntmapm) then
         write(*,*) ' ntrack>ntmapm - abunai! '
         stop
         endif
         do j = 1, npart
         do i = 1, ntrack
         xn(j,i) = 0.
         yn(j,i) = 0.
         pxn(j,i) = 0.
         pyn(j,i) = 0.
         end do 
         xn(j,1) = x(j)/sstar
         yn(j,1) = y(j)/sstar
         pxn(j,1) = px(j)/divstar
         pyn(j,1) = py(j)/divstar
         end do 
       else if (iopt.eq.1) then
c        short term tracking      
         ntrack=500
         npart=15
cc       ntrack=2
cc       npart=2
         write(*,*) ' option 1 ',npart,sstar,divstar,emit
         call initcoordunir 
         write(*,*) x(15), y(15)
       else
c        the normal case 
         call initcoord 
       endif 

         write(*,*) ' after initialization '

       if (iopt.eq.3) then
       open(24,file="footprint.dat")
       else if (iopt.eq.2) then
       open(23,file="frequencymap.dat")
       else if (iopt.eq.1) then
       open(22,file="phasespace.dat")
       else 
       open(20,file="diff.dat")
       open(21,file="resav.out")
       endif 

c       write(*,*) ' ichoice decision '  

       ichoice = ich 
c      ichoice = 0, only short range
c      ichoice = 1, only long range
c      ichoice = 2, lr + sr 

       itrip = itri 
c      itrip = 0, no triplet fields
c      itrip = 1, with nonlinear triplet fields
c       write(*,*) ' itrip = ',itrip 

c       write(*,*) ' triplet initialization '

       if (itrip.eq.1) then
       call tripletin
       endif 

       write(*,*) '  '
       write(*,*) ' start tracking '
       write(*,*) ' ioption = ', iopt
       write(*,*) ' ichoice = ', ich
       write(*,*) ' itrip = ', itrip
       write(*,*) ' ------------------------- '
       write(*,*) '  '

       write(*,*) ' srparam = ', srparam
       write(*,*) ' npar = ', npar

       do i = 1, ntrack

c       if (mod(i,50).eq.0) then
c       write(*,*) ' i = ',i
c       endif 

       call rot(phix1,phiy1)

c       write(*,*) ' after rot ', npart  

       call bbkick2(ichoice,itrip)

c       write(*,*) ' after bbkick2 '        

       call rot(phix2,phiy2)

c       call bbkicky2(ichoice,itrip) 

c       write(*,*) ' after bbkicky2 ' 

       time = real(i)*timeconv        
       call tunemod (time) 

       call overflow

       if (iopt.ne.1) then
       call var(amx,amy) 
       amxav = amx
       amyav = amy
       ipoint = i
       call runav(amx,amy,amxav,amyav,ipoint) 

c       if (i.gt.15000) then
c       write(*,*) i, amx, amy 
c       endif 

c       if (i.eq.1) then
c         axinit = amx
c         ayinit = amy
c         iinit = i
c       endif       
       if (i.eq.nav) then
         axinit = amxav
         ayinit = amyav
         iinit = i
       endif       
c       if (i.eq.(ntrack/2)) then
c         axinit = amxav
c         ayinit = amyav
c         iinit = i
c       endif

       if (nloss.gt.0.and.i.gt.(2*nav)) then
         axfin = amxav
         ayfin = amyav
         iifin = i 
         goto 890         
       endif

       if (i.eq.ntrack) then
         axfin = amxav
         ayfin = amyav         
         iifin = i 
       endif
       if (i.ge.nav) then
         if (mod(i,nprint).eq.0) then
         write(20,888)  i, time, amxav, amyav, nloss, npart
 888     format(i5,3(1x,e10.3),1x,i3,1x,i3)
         endif 
       endif 
       amynt=dmin1(amynt,amyav)
       amyxt=dmax1(amyxt,amyav)
       amxnt=dmin1(amxnt,amxav)
       amxxt=dmax1(amxxt,amxav)       
       endif

       if (iopt.eq.3) then
       do j = 1, npart
       xx = x(j)/sstar
       yy = y(j)/sstar
       xp = px(j)/divstar
       yp = py(j)/divstar
       acomplx(indexfp1(j),indexfp2(j),i)=cmplx(xx,xp) 
       acomply(indexfp1(j),indexfp2(j),i)=cmplx(yy,yp) 
c       if (j.eq.10) then
c       write(*,*) ' j=10, turn= ',i, cmplx(xx,xp) 
c       endif 
c      CALL CFSTFT(M,A)
c       write(24,922) i, indexfp1(j), indexfp2(j),
c     &               xx, xp, yy, yp
c 922   format(3(1x,i5),4(1x,e10.4))
       end do
       endif

       if (iopt.eq.1.or.iopt.eq.2) then
       do j = 1, npart
       xx = x(j)/sstar
       yy = y(j)/sstar
       xp = px(j)/divstar
       yp = py(j)/divstar
       if (iopt.eq.1) then
       write(22,910) i, xx, xp, yy, yp
 910   format(1x,i5,4(1x,e10.4))
       else if(iopt.eq.2) then

       ih = i+1
       if(ih.le.ntrack)then
       xn(j,ih) = xx
       yn(j,ih) = yy
       pxn(j,ih) = xp
       pyn(j,ih) = yp
       endif 
       endif 
       end do 
       endif 

       end do 

 890   continue

       write(*,*) ' after tracking loop ',i 

       if (iopt.eq.3) then
       do ik = 0, 10 
       do ik2 = 0, 10 
       do i = 0, ntrack-1        
       a1dx(i)=acomplx(ik,ik2,i+1)
       a1dy(i)=acomply(ik,ik2,i+1)
       a1xre(i)=real(a1dx(i))  
       a1yre(i)=real(a1dy(i))  
c       write(*,*)  i,a1xre(i), a1yre(i)
      enddo
       mt = 12
       ix=1
       iy=1
c       CALL RCA(Mt,a1Xre,IX,Xre,IY) 
c       CALL RCA(Mt,a1Yre,IX,Yre,IY)  
c       write(*,*) ' calling cfstft ... ' 
c       write(*,*) a1dx, mt 
       call c06ecf(a1xre,a1xim,ntrack,ifail)
       call c06ecf(a1yre,a1yim,ntrack,ifail)
c       CALL CFSTFT(mt,A1dx)
c       CALL CFSTFT(mt,A1dy)
c       acomply(indexfp1(j),indexfp2(j),i)=cmplx(yy,yp) 
       do i = 0, ntrack-1
       a1dx(i)=cmplx(a1xre(i),a1xim(i))
       a1dy(i)=cmplx(a1yre(i),a1yim(i))
       end do
       amx = 0.
       amy = 0.
       do i = 0, ntrack-1        
       if (abs(a1dx(i)).gt.amx) then
        indx = i 
        amx = abs(a1dx(i))
       endif 
       end do
       do i = 0, ntrack-1      
       if (abs(a1dy(i)).gt.amy) then
        indy = i 
        amy = abs(a1dy(i))
       endif 
       end do
       tunex = real(indx)/ntrack 
       tuney = real(indy)/ntrack 
       if (tunex.gt.0.5) tunex=1.-tunex
       if (tuney.gt.0.5) tuney=1.-tuney
       write(*,*) ik, ik2,tunex,tuney
       write(24,922) ik, ik2, tunex, tuney
 922   format(2(1x,i5),2(1x,e10.4))
       enddo
       enddo
       endif

       if (iopt.eq.0) then
       slopex = (axfin-axinit)/real(iifin-iinit)
       slopey = (ayfin-ayinit)/real(iifin-iinit)
       write(21,900) ampl,slopex,slopey,ichoice,qx1,qx2,qy1,qy2 
 900   format(1x,3(1x,e10.4),1x,i2,1x,4(1x,e10.4))
       endif 

       if(iopt.eq.2) then
       do j = 1, npart
       do i = 1, ntrack 
       write(23,912) xn(j,i),pxn(j,i),yn(j,i),pyn(j,i)
 912   format(4(1x,e18.12))
       end do 
       end do 
       endif 

       if (iopt.eq.1) then
       close(22)
       else
       close(20)
       close(21)
       endif 

       write(*,*) ' lost particles = ',nloss

       end 

c
       INCLUDE 'init2.f'

       INCLUDE 'var.f'

       INCLUDE 'kicksr.f'

       INCLUDE 'kicklr.f'

       INCLUDE 'rot.f'

       INCLUDE 'bbkick2.f'

       INCLUDE 'bbkicky2.f'

       INCLUDE 'tunemod.f'

       INCLUDE 'initcoord.f'

       INCLUDE 'initcoorduni.f'

       INCLUDE 'initcoordunir.f'

       INCLUDE 'initcoordfp.f'

       INCLUDE 'runav.f'

       INCLUDE 'kicklry.f'

       INCLUDE 'kicktripnew.f'

       INCLUDE 'kicktripynew.f'

       INCLUDE 'tripletinnew.f'

       INCLUDE 'overflow.f'

       INCLUDE 'readin.f'

       INCLUDE 'ran2.f'

c      INCLUDE 'moebius.f'
    
