c     test beambeam kick
c      subroutine kickfnal(xt,yt,dpx,dpy,ipoint)
c     input : xt, yt
c     output : dpx, dpy

      INCLUDE 'param.f'
      INCLUDE 'paramfnal.f'
 
c      xt = 0. 
c      yt = 0.

      xmin = -0.003
      xmax = 0.003
      nm=100
      xstep=(xmax-xmin)/real(nm)          
      yt = 0.00001
      sx = 0.00054
      sy = 0.00052
      xoff=0.
      yoff=0.
      factor=1.

      do i = 0, nm
      yt = xmin+real(i)*xstep
      xt = 0.005
      xta = dabs(xt-xoff)
      yta = dabs(yt-yoff)

      call ffrank(xt,yt,xoff,yoff,sx,sy,pre,pim) 

      dkickx = - pim * factor
c     *(xt-xoff)/xta
c     &         - pimfnal(ipoint)*factor*xoff/abs(xoff)
      dkicky = - pre * factor
c     *(yt-yoff)/yta
c     &         - prefnal(ipoint)*factor*yoff/abs(yoff)       

c      write(*,*) dkickx,' ',dkicky
c      stop

      write(*,*) xt,yt,dkickx,dkicky
      end do

      return
      end 


c----------------------------------------------------------
       subroutine ffrank(x,y,xof,yof,sx,sy,fr,fi)
c      25.08.99 FZ, include offset xof, yof to be 
c               consistent with foliver 

       implicit real*8 (a-h,o-z)
c       implicit integer (a-z)
       double precision sx1,sy1,xt,yt
       real*8 x,y,sx,sy,fr,fi

       isxsyflag = 0
       if (sy.gt.sx) then
           syold=sy
           sxold=sx
           xold=x
           yold=y
           isxsyflag = 1 
       endif 

c      new variables  
       if (isxsyflag.eq.0) then
       dx = x-xof
       dy = y-yof
       else 
       dy = -x+xof
       dx = y-yof 
       sx = syold
       sy = sxold
       endif

       pi = 4.*datan(1.0d0)
       xt = abs(dx)
       yt = abs(dy)
       r = sqrt(xt*xt+yt*yt) 
       resmod = 2./sqrt(2.*pi)
c       if (r.gt.(10.0d0*sx)) then
       pi = 4.0d0*atan(1.0d0)
       res = 2.0d0/sqrt(2.0d0*pi)/(r*r)
       sx1 = sx
       sy1 = sy

       if (abs((sx/sy)-1.0d0).lt.1.0d-2) then
       co = (1.0d0-exp(-r*r/(2.0d0*sx1*sy1)))
       fr = res*co*yt*(dy/yt)
       fi = res*co*xt*(dx/xt)

          if (isxsyflag.eq.1) then
          sx = sxold
          sy = syold
          fitemp = fi 
          fi = -fr
c         Fx = (-)Fy 
          fr = fitemp 
c         Fy = Fx 
          endif

       return

       else  
c      flat beam        

c       fr2 = resmod * yt/r * co *(dy/yt)
c       fi2 = resmod * xt/r * co *(dx/xt)

       call bbkick(pre1,pre2,pim1,pim2,xt,yt,sx1,sy1)
       expon = dexp(-xt**2/(2.d0*sx1**2)-yt**2/(2.d0*sy1**2))
       fr1 = ( pre1 - expon * pre2 )/ sqrt(sx*sx-sy*sy)*(dy/yt)
       fi1 = ( pim1 - expon * pim2 ) / sqrt(sx*sx-sy*sy)*(dx/xt)

       fr = fr1 
       fi = fi1
 
c 
c       den = sqrt((40.*sx)**2+r*r)
c       w1 = 40.*sx/den
c       w2 = 1./den

c       fr = w1 * fr1 + w2 * fr2 
c       fi = w1 * fi1 + w2 * fi2 

          if (isxsyflag.eq.1) then
          sx = sxold
          sy = syold
          fitemp = fi 
          fi = -fr
c         Fx = (-)Fy 
          fr = fitemp 
c         Fy = Fx 
          endif

       return 
       endif 
       end

c----------------------------------------------------------


c---------------------------------------------------------       
c      this routine converts into the first quadrant
c      and then calls Tong's/Talman's programs 
c 
       subroutine bbkick(pre1,pre2,pim1,pim2,x,y,sx,sy)
       implicit double precision(a-h,o-z)
       fac = dsqrt(2.d0*(sx**2-sy**2))
       r = sy/sx 
       u = x 
       v = y 
c       u = x / fac
c       v = y / r / fac
       u1 = dabs(u)
       v1 = dabs(v)

       u1a = u1 / fac
       v1a = v1 / fac 
       call errf(u1a,v1a,wr1,wi1)

       u1b = u1 / fac * r 
       v1b = v1 / fac / r 
       call errf(u1b,v1b,wr2,wi2)

       pre1 = wr1 
       pre2 = wr2
       pim1 = wi1 
       pim2 = wi2
  
       goto 900

       texp1 = 2.d0*dexp(-u**2+(r*v)**2)
       texp2 = 2.d0*dexp(-(r*u)**2+v**2)
       arguvr = 2.d0*u*r*v 

       if(u.gt.0.and.v.gt.0)then 
       call fbbclc(wr1,wr2,wi1,wi2,u,v,r)
       pre1 = wr1 
       pre2 = wr2
       pim1 = wi1 
       pim2 = wi2

       else if(u.gt.0.and.v.lt.0)then 
       call fbbclc(wr1,wr2,wi1,wi2,u,-v,r)
       pre1 = texp1*dcos(arguvr)-wr1 
       pre2 = texp2*dcos(arguvr)-wr2
       pim1 = texp1*dsin(arguvr)+wi1 
       pim2 = texp2*dsin(arguvr)+wi2

       else if(u.lt.0.and.v.gt.0)then 
       call fbbclc(wr1,wr2,wi1,wi2,-u,v,r)
       pre1 = wr1 
       pre2 = wr2
       pim1 = -wi1 
       pim2 = -wi2

       else if(u.lt.0.and.v.lt.0)then 
       call fbbclc(wr1,wr2,wi1,wi2,-u,-v,r)
       pre1 = texp1*dcos(arguvr)-wr1 
       pre2 = texp2*dcos(arguvr)-wr2
       pim1 = -texp1*dsin(arguvr)-wi1 
       pim2 = -texp2*dsin(arguvr)-wi2

       endif 

 900   continue 
       end 
c
c ####################################################################
c
c                                  2   2  2
c                             -(1-r )(v +u )
c      f(u,v,r) = w(u+irv) - e              w(ru+iv)
c
c ####################################################################
c
       subroutine fbbclc(wr1,wr2,wi1,wi2,u,v,r)
       implicit double precision(a-h,o-z)
       call errf(u,r*v,wr1,wi1)
       call errf(r*u,v,wr2,wi2)
       arg=(1.0-r*r)*(v*v+u*u)
       if(arg.gt.100.) then
         arg = 100.
         wr2 = 0.0
         wi2 = 0.0
       endif
       expon=exp(-arg)
c
       fr=wr1-expon*wr2
       fi=wi1-expon*wi2
       return
       end
c
c                 fnctnw.fortran
c
c          this program evaluates the function w(z)
c       (where z = zr +  zi) in the first quadrant of
c       the complex plane (i.e. zr > 0 and zi > 0).
c       three different expressions, pade1, pade2, and
c       asymp, are used, depending on where z lies in
c       the quadrant.
c
       subroutine fcnw(wr,wi,zr,zi)
       implicit double precision(a-h,o-z)
       data x1/4.1e0/,x2/3.6e0/,x3/3.5e0/,x4/2.7e0/,x5/2.2e0/
       data y1/1.275e0/,y2/1.095e0/
       data r2/8.7025e0/
        if(zr-x1)200,30,30
200        eps1=.0625e0*(zr-x3)
           if(zr-x2)300,210,210
210          yc=-1.4e0*(zr-x2)+y2
          if(zi-yc)220,30,30
220       if(zr*zi.lt.eps1)then
          call asymp(wr,wi,zr,zi)
          else
          call pade2(wr,wi,zr,zi)
          endif
300        if(zr-x4)400,310,310
310          yc=-.2e0*(zr-x4)+y1
          if(zi-yc)320,30,30
320       if(zr.ge.x3.and.zr*zi.lt.eps1) then
          call asymp(wr,wi,zr,zi)
          else
          call pade2(wr,wi,zr,zi)
          endif
400        if(zr-x5)500,410,410
410          yc1=-1.4e0*(zr-x4)+y1
          yc2=1.75e0*(zr-x4)+y1
          if(zi-yc1)420,30,30
420          if(zi-yc2)20,10,10
500        if(zr*zr+zi*zi-r2)10,30,30
10        call pade1(wr,wi,zr,zi)
        return
20        call pade2(wr,wi,zr,zi)
        return
30        call asymp(wr,wi,zr,zi)
        return
       end
     
c                 wasymp.fortran
c
c          this program calculates an asymptotic expression of
c       w(z) valid away from the origin.
c
       subroutine asymp(wr,wi,zr,zi)
       implicit double precision(a-h,o-z)
       data a1p/1.94443615e-1/,a2p/7.64384940e-2/,
     1   a3p/1.07825546e-2/,a4p/4.27695730e-4/,a5p/2.43202531e-6/
       data b1/3.42901327e-1/,b2/1.036610830e0/,b3/1.756683649e0/,
     1   b4/2.532731674e0/,b5/3.436159119e0/
       data pi2/1.12837917e0/
       data x1/3.5e0/,x2/4.2e0/
       data eps/.01e0/,check/0.e0/
10        dr1=zr+b1
        d1r=zr-b1
        dr2=zr+b2
        d2r=zr-b2
        dr3=zr+b3
        d3r=zr-b3
        dr4=zr+b4
        d4r=zr-b4
        dr5=zr+b5
        d5r=zr-b5
        de1=dr1*dr1+zi*zi
        d1e=d1r*d1r+zi*zi
        de2=dr2*dr2+zi*zi
        d2e=d2r*d2r+zi*zi
        de3=dr3*dr3+zi*zi
        d3e=d3r*d3r+zi*zi
        de4=dr4*dr4+zi*zi
        d4e=d4r*d4r+zi*zi
        de5=dr5*dr5+zi*zi
        d5e=d5r*d5r+zi*zi
        if(1.e0-check)70,70,20
20          if(zr.lt.x1) goto 60
            eps1=.04e0/(zr-3.29e0)-.034e0
            if(zr*zi.lt.eps1) goto 50
            if(.not.((zr.ge.x2).and.(zr*zi.lt.eps))) goto 60
50          check=1.e0
          wi0=a1p*(dr1/de1+d1r/d1e)+a2p*(dr2/de2+d2r/d2e)+
     1         a3p*(dr3/de3+d3r/d3e)+a4p*(dr4/de4+d4r/d4e)+
     1         a5p*(dr5/de5+d5r/d5e)
          zi0=zi
          zi=0.e0
          go to 10
60        wr=(a1p*(1.e0/de1+1.e0/d1e)+a2p*(1.e0/de2+1.e0/d2e)+
     1      a3p*(1.e0/de3+1.e0/d3e)+a4p*(1.e0/de4+1.e0/d4e)+
     1      a5p*(1.e0/de5+1.e0/d5e))*zi
70        wi=a1p*(dr1/de1+d1r/d1e)+a2p*(dr2/de2+d2r/d2e)+
     1      a3p*(dr3/de3+d3r/d3e)+a4p*(dr4/de4+d4r/d4e)+
     1      a5p*(dr5/de5+d5r/d5e)
        if(1.e0-check)80,80,90
80        wr=exp(-zr*zr)+2.e0*wi*zr*zi0-pi2*zi0
        wi=wi0
        zi=zi0
        check=0.e0
90        return
c
c  ##################################################################
c  ######################################################################
       entry errasymp
c
       write(41,*)'zi,zr,ck=',zi,zr,ck
       return
c
       end
     
c                 wpade1.fortran
c
c          this program calculates a pade approximation of w(z)
c       around the origin.
c
       subroutine pade1(wr,wi,zr,zi)
       implicit double precision(a-h,o-z)
       data c1/-1.25647718e0/,c2/8.25059158e-1/,
     1   c3/-3.19300157e-1/,c4/7.63191605e-2/,
     1   c5/-1.04697938e-2/,c6/6.44878652e-4/
       data d1/-2.38485635e0/,d2/2.51608137e0/,
     1   d3/-1.52579040e0/,d4/5.75922693e-1/,
     1   d5/-1.35740709e-1/,d6/1.85678083e-2/,
     1   d7/-1.14243694e-3/
        u2r=zi*zi-zr*zr
        u2i=-2.e0*zr*zi
        u3r=-u2r*zi-u2i*zr
        u3i=u2r*zr-u2i*zi
        u4r=-u3r*zi-u3i*zr
        u4i=u3r*zr-u3i*zi
        u5r=-u4r*zi-u4i*zr
        u5i=u4r*zr-u4i*zi
        u6r=-u5r*zi-u5i*zr
        u6i=u5r*zr-u5i*zi
        u7r=-u6r*zi-u6i*zr
        u7i=u6r*zr-u6i*zi
        fr=1.e0-c1*zi+c2*u2r+c3*u3r+c4*u4r+c5*u5r+c6*u6r
        fi=c1*zr+c2*u2i+c3*u3i+c4*u4i+c5*u5i+c6*u6i
        dr=1.e0-d1*zi+d2*u2r+d3*u3r+d4*u4r+d5*u5r+d6*u6r+d7*u7r
        di=d1*zr+d2*u2i+d3*u3i+d4*u4i+d5*u5i+d6*u6i+d7*u7i
        de=dr*dr+di*di
         wr=(fr*dr+fi*di)/de
        wi=(fi*dr-fr*di)/de
       return
       end
     
c                 wpade2.fortran
c
c          this program calculates a pade approximation of w(z)
c       around the point z = 3.
c
       subroutine pade2(wr,wi,zr,zi)
       implicit double precision(a-h,o-z)
       data c0r/1.23409804e-4/,c0i/2.01157318e-1/,
     1   c1r/2.33746715e-1/,c1i/1.61133338e-1/,
     1   c2r/1.25689814e-1/,c2i/-4.0422725e-2/,
     1   c3r/8.92089179e-3/,c3i/-1.81293213e-2/
       data d1r/1.19230984e0/,d1i/-1.16495901e0/,
     1   d2r/8.9401545e-2/,d2i/-1.07372867e0/,
     1   d3r/-1.68547429e-1/,d3i/-2.70096451e-1/,
     1   d4r/-3.20997564e-2/,d4i/-1.58578639e-2/
        zr=zr-3.e0
        z2r=zr*zr-zi*zi
        z2i=2.e0*zr*zi
        z3r=z2r*zr-z2i*zi
        z3i=z2r*zi+z2i*zr
        z4r=z3r*zr-z3i*zi
        z4i=z3r*zi+z3i*zr
        fr=c0r+c1r*zr-c1i*zi+c2r*z2r-c2i*z2i+c3r*z3r-c3i*z3i
        fi=c0i+c1r*zi+c1i*zr+c2r*z2i+c2i*z2r+c3r*z3i+c3i*z3r
        dr=1.e0+d1r*zr-d1i*zi+d2r*z2r-d2i*z2i+d3r*z3r-d3i*z3i+
     1      d4r*z4r-d4i*z4i
        di=d1r*zi+d1i*zr+d2r*z2i+d2i*z2r+d3r*z3i+d3i*z3r+d4r*z4i+
     1      d4i*z4r
        de=dr*dr+di*di
        wr=(fr*dr+fi*di)/de
        wi=(fi*dr-fr*di)/de
        zr=zr+3.e0
       return
       end



      SUBROUTINE ERRF(XX, YY, WX, WY)                                      
*----------------------------------------------------------------------*   
* Purpose:                                                             *   
*   Modification of WWERF, double precision complex error function,    *   
*   written at CERN by K. Koelbig.                                     *   
* Input:                                                               *   
*   XX, YY    (real)    Argument to CERF.                              *   
* Output:                                                              *   
*   WX, WY    (real)    Function result.                               *   
*----------------------------------------------------------------------*   
                                                                           
*---- Double precision version.                                            
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)                   
      PARAMETER         (MWFLT = 2, MREAL = 4)                             
      PARAMETER         (MCWRD = 4)                                        
      PARAMETER         (MCNAM = 16, MWNAM = MCNAM / MCWRD)                
      PARAMETER         (MCFIL = 80, MCRNG = 40, MCSTR = 80)               
                                                                           
      PARAMETER         (CC     = 1.12837 91670 9551D0)                    
      PARAMETER         (ONE    = 1.D0)                                    
      PARAMETER         (TWO    = 2.D0)                                    
      PARAMETER         (XLIM   = 5.33D0)                                  
      PARAMETER         (YLIM   = 4.29D0)                                  
      DIMENSION         RX(33), RY(33)                                     
                                                                           
      X = ABS(XX)                                                          
      Y = ABS(YY)                                                          
                                                                           
      IF (Y .LT. YLIM  .AND.  X .LT. XLIM) THEN                            
        Q  = (ONE - Y / YLIM) * SQRT(ONE - (X/XLIM)**2)                    
        H  = ONE / (3.2D0 * Q)                                             
        NC = 7 + INT(23.0*Q)                                               
        XL = H**(1 - NC)                                                   
        XH = Y + 0.5D0/H                                                   
        YH = X                                                             
        NU = 10 + INT(21.0*Q)                                              
        RX(NU+1) = 0.                                                      
        RY(NU+1) = 0.                                                      
                                                                           
        DO 10 N = NU, 1, -1                                                
          TX = XH + N * RX(N+1)                                            
          TY = YH - N * RY(N+1)                                            
          TN = TX*TX + TY*TY                                               
          RX(N) = 0.5D0 * TX / TN                                          
          RY(N) = 0.5D0 * TY / TN                                          
   10   CONTINUE                                                           
                                                                           
        SX = 0.                                                            
        SY = 0.                                                            
                                                                           
        DO 20 N = NC, 1, -1                                                
          SAUX = SX + XL                                                   
          SX = RX(N) * SAUX - RY(N) * SY                                   
          SY = RX(N) * SY + RY(N) * SAUX                                   
          XL = H * XL                                                      
   20   CONTINUE                                                           
                                                                           
        WX = CC * SX                                                       
        WY = CC * SY                                                       
      ELSE                                                                 
        XH = Y                                                             
        YH = X                                                             
        RX(1) = 0.                                                         
        RY(1) = 0.                                                         
                                                                           
        DO 30 N = 9, 1, -1                                                 
          TX = XH + N * RX(1)                                              
          TY = YH - N * RY(1)                                              
          TN = TX*TX + TY*TY                                               
          RX(1) = 0.5D0 * TX / TN                                          
          RY(1) = 0.5D0 * TY / TN                                          
   30   CONTINUE                                                           
                                                                           
        WX = CC * RX(1)                                                    
        WY = CC * RY(1)                                                    
      ENDIF                                                                
                                                                           
      IF(Y .EQ. 0.) WX = EXP(-X**2)                                        
      IF(YY .LT. 0.) THEN                                                  
        WX =   TWO * EXP(Y*Y-X*X) * COS(TWO*X*Y) - WX                      
        WY = - TWO * EXP(Y*Y-X*X) * SIN(TWO*X*Y) - WY                      
        IF(XX .GT. 0.) WY = -WY                                            
      ELSE                                                                 
        IF(XX .LT. 0.) WY = -WY                                            
      ENDIF                                                                
                                                                           
      END



