c      computes table of 10000 random triplet errors
c      
       implicit double precision (a-h,o-z)
       real*8 au(10),arms(10),bu(10),brms(10), rn(8000), frn(8000)
       real*8 ao(10),bo(10), betag(16), signtrip(16), rn2(8000)
       real*8 rn3(8000)
       real*8 asum(10), bsum(10), asum2(10), bsum2(10)

       Parameter (ia=16807,im=2147483647,am=1./im,iq=127773,ir=2836,
     &           mask=123459876) 
 
c      initial seed

       idum=12984
       idum=12987
       idum=13890

       pi=4.*datan(1.d0)

c      velocity of light
       vl = 3.e8
c
       ex0=1.
       ey0=1.

       bu(1) = 0.
       brms(1) = 0.
       bu(2) = 0.
       brms(2) = 0.
       au(1) = 0.
       arms(1) = 0.
       au(2) = 0.
       arms(2) = 0.

c      mean and rms of triplet errors
       bu(3) = .3
       brms(3) = .8
       bu(4) = .2
       brms(4) = .8
       bu(5) = .2
       brms(5) = .3
       bu(6) = .6
       brms(6) = .6
       bu(7) = .05
       brms(7) = .06
       bu(8) = .03
       brms(8) = .05
       bu(9) = .02
       brms(9) = .03
       bu(10) = .02
       brms(10) = .03

       au(3) = .3
       arms(3) = .8
       au(4) = .2
       arms(4) = .8
       au(5) = .2
       arms(5) = .3
       au(6) = .05
       arms(6) = .1
       au(7) = .04
       arms(7) = .06
       au(8) = .03
       arms(8) = .04
       au(9) = .02
       arms(9) = .02
       au(10) = .02
       arms(10) = .03

c      average mean beta function at 16 triplet quadrupoles
       betag(1) = sqrt(1257*1485.)
       betag(2) = sqrt(1171*4104.)
       betag(3) = sqrt(1747*4545.)
       betag(4) = sqrt(4469.*2230)
       betag(5) = sqrt(1257*1485.)
       betag(6) = sqrt(1171*4104.)
       betag(7) = sqrt(1747*4545.)
       betag(8) = sqrt(4469.*2230)
       betag(9) = sqrt(1257*1485.)
       betag(10) = sqrt(1171*4104.)
       betag(11) = sqrt(1747*4545.)
       betag(12) = sqrt(4469.*2230)
       betag(13) = sqrt(1257*1485.)
       betag(14) = sqrt(1171*4104.)
       betag(15) = sqrt(1747*4545.)
       betag(16) = sqrt(4469.*2230)

       signtrip(1) = 1.
       signtrip(2) = -1.
       signtrip(3) = -1.
       signtrip(4) = 1.
       signtrip(5) = 1.
       signtrip(6) = -1.
       signtrip(7) = -1.
       signtrip(8) = 1.
       signtrip(9) = 1.
       signtrip(10) = -1.
       signtrip(11) = -1.
       signtrip(12) = 1.
       signtrip(13) = 1.
       signtrip(14) = -1.
       signtrip(15) = -1.
       signtrip(16) = 1.

       open(20,FILE='multdist.dat',iostat=ios)

       do 15 i = 1, 8000       
       idum=ieor(idum,mask)
       k=idum/iq
       idum=ia*(idum-k*iq)-ir*k
       if(idum.lt.0) idum=idum+IM
       rn2(i) = am*idum
 15    end do 
       iseed = idum 

       do 20 i= 1, 8000    
       k=idum/iq
       idum=ia*(idum-k*iq)-ir*k
       if(idum.lt.0) idum=idum+IM
       randu = am*idum     
       rn(i)= - alog(real(randu))
 20    end do
       iseed = idum 

       do 30 i= 1, 8000
       rn3(i) = sin(2.*pi*rn2(i))*sqrt(rn(i))
 30    end do 

       open(11,file="test.dat")
       do i =1, 200
       write(11,*) rn3(i)
       end do
       close(11)

       index = 0

       do j = 1, 10
       index = index+1 
       bo(j) = rn3(index)*bu(j)
       index = index+1
       ao(j) = rn3(index)*au(j)
       end do


       do j = 1, 10 
       asum(j) = 0.
       bsum(j) = 0.
       asum2(j) = 0.
       bsum2(j) = 0.
       end do 

       do i = 1, 160
       do j = 1, 10
       index = index+1
       b = bo(j) + rn3(index)*brms(j)
       index = index+1
       a = ao(j) + rn3(index)*arms(j)
       asum(j)= asum(j) + a
       bsum(j)= bsum(j) + b
       asum2(j)= asum2(j) + a*a
       bsum2(j)= bsum2(j) + b*b
       write(20,*) b, a 
       enddo
       write(20,*) ' ' 
       enddo

  
       do j =1, 10 
       ameant = asum(j)/real(160) 
       bmeant = bsum(j)/real(160) 
       armst = sqrt(asum2(j)/real(160)-ameant**2)
       brmst = sqrt(bsum2(j)/real(160)-bmeant**2)
       write(*,*) j, bmeant, ameant, brmst, armst
       end do

       do i = 1, 16
       write(20,*) betag(i)
       enddo
       write(20,*) ' ' 

       do i = 1, 16
       write(20,*) signtrip(i)
       enddo
       write(20,*) ' ' 

       close(20)

       end       

   
        




