      real*8 function   ran2(idum)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   The Function Returns a Uniform Random Number between 0.0 and 1.0.
c
c   The Function uses a 'Subtractive Method'!!!
c
c   Set 'idum' to a negative value to initialize or reinitialize the Sequence.
c
c   (Numerical Recipies ran3(idumy), pg. 273.)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer    idum
      integer    mbig, mseed, mz
      real*8     fac 
      parameter(mbig=1000000000,mseed=161803398,mz=0,fac=1.0d0/mbig)
      integer    i, iff, ii, inext, inextp, k
      integer    mj, mk, ma(55)
      save       iff, inext, inextp, ma
      data       iff /0/

c     Initialization:
      if(idum.lt.0.or.iff.eq.0) then
            iff = 1
            mj = mseed-iabs(idum)
            mj = mod(mj,mbig)
            mk = 1
            do 11 i=1,54
               ii = mod(2*i,55)
               ma(ii) = mk
               mk = mj - mk
               if(mk.lt.mz) mk = mk + mbig
               mj = ma(ii)
 11         continue  

            do 13 k=1,4
               do 12 i=1,55
                  ma(i) = ma(i) - ma(1+mod(i+30,55))
                  if(ma(i).lt.mz) ma(i) = ma(i) + mbig
 12            continue
 13         continue
            inext = 0
            inextp = 31
            idum = 1
       end if

       inext = inext + 1
       if(inext.eq.56) inext = 1
       inextp = inextp + 1
       if(inextp.eq.56) inextp = 1
       mj = ma(inext) - ma(inextp)
       if(mj.lt.mz) mj = mj + mbig
       ma(inext) = mj
       ran2 = mj * fac

       return
       end

